﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.IO;
using System.Diagnostics;
using System.ComponentModel;

namespace Diplomski
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class
        MainWindow : Window
    {
        FileStream fs; StreamReader sr; string tekst = "";
        List<Profesor> profesori = new List<Profesor>();
        List<Prostorija> prostorije = new List<Prostorija>();

        DataSet1TableAdapters.ProfesoriTableAdapter taP;
        DataSet1TableAdapters.RokoviTableAdapter taR;
        DataSet1TableAdapters.IspitiTableAdapter taI;
        DataSet1TableAdapters.ProstorijaTableAdapter taProstorija;
        DataSet1TableAdapters.ZakazaniTableAdapter taZ;
        public MainWindow()
        {
            InitializeComponent();
            taP = new Diplomski.DataSet1TableAdapters.ProfesoriTableAdapter();
            taR = new Diplomski.DataSet1TableAdapters.RokoviTableAdapter();
            taProstorija = new Diplomski.DataSet1TableAdapters.ProstorijaTableAdapter();
            taI = new Diplomski.DataSet1TableAdapters.IspitiTableAdapter();
            taZ = new Diplomski.DataSet1TableAdapters.ZakazaniTableAdapter();

            
            //fs = new FileStream("Zoran Banjac.txt", FileMode.Open, FileAccess.Read);
            //sr = new StreamReader(fs);
            //while (!sr.EndOfStream)
            //    tekst += sr.ReadLine();
            //sr.Close();


        }

        public class Profesor
        {
            private string ime, image, biografija , kabinet , konsultacije, email ;
            private int id;

            public Profesor(int Id, string Ime, string Image, string Kabinet, string Konsultacije,string Email, string Biografija )
            {
                id = Id; ime = Ime; image = Image; kabinet = Kabinet;
                konsultacije = Konsultacije; email = Email; biografija = Biografija;
            }

            public string Ime
            {
                get { return ime; }
                set { ime = value; }
            }

            public string Image
            {
                get { return image; }
                set { image = value; }
            }

            public string Kabinet
            {
                get { return kabinet; }
                set { kabinet = value; }
            }

            public string Konsultacije
            {
                get { return konsultacije; }
                set { konsultacije = value; }
            }

            public string Email
            {
                get { return email; }
                set { email = value; }
            }

            public string Biografija
            {
                get { return biografija; }
                set { biografija = value; }
            }

            public int ID
            {
                get { return id; }
                set { id = value; }
            }
        }

        public class Prostorija
        {
            private int kapacitet;
            private string naziv;
            private bool check;

            public Prostorija(int Kap, bool Check, string Naziv)
            {
                kapacitet = Kap; check = Check; naziv = Naziv;
            }

            public int Kapacitet
            {
                get { return kapacitet; }
                set { kapacitet = value; }
            }
            public bool Check
            {
                get { return check; }
                set { check = value; }
            }
            public string Naziv
            {
                get { return naziv; }
                set { naziv = value; }
            }
        }

        public void ucitaj_DataGrid()
        {
            DataSet1.RokoviDataTable dtR = taR.GetData();
            DataSet1.ProfesoriDataTable dtP = taP.GetData();
            DataSet1.IspitiDataTable dtI = taI.GetData();
            DataSet1.ProstorijaDataTable dtProstorija = taProstorija.GetData();
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();

            DataTable dtZakazani = new DataTable();
            dtZakazani.Columns.Add("ID", typeof(int));
            dtZakazani.Columns.Add("Profesor", typeof(string));
            dtZakazani.Columns.Add("SifraIspita", typeof(string));
            dtZakazani.Columns.Add("NazivIspita", typeof(string));
            dtZakazani.Columns.Add("Prostorija", typeof(string));
            dtZakazani.Columns.Add("Rok", typeof(string));
            dtZakazani.Columns.Add("Datum", typeof(string));
            dtZakazani.Columns.Add("Vreme", typeof(string));

            string profDG = "", sifraIspitaDG = "", nazivIspitaDG = "", prostorijaDG = "";

            bool pom = false, pom1 = false; int j = 0, i = 0;
            int[] niz = new int[4 * dtZ.Rows.Count];

            foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
            {
                pom1 = false;
                foreach (int br in niz) { if (br.Equals(r.ID)) pom1 = true; } i++;
                if (pom1) continue;

                foreach (DataSet1.ProfesoriRow rp in dtP.Rows)
                {
                    
                    if (r.id_prof.Equals(rp.ID))
                        profDG += " " + rp.Ime + " " + rp.Prezime + " "; 
                }
                foreach (DataSet1.IspitiRow ri in dtI.Rows)
                {
                    if (r.id_ispita.Equals(ri.Sifra))
                    { sifraIspitaDG = " " + ri.Sifra + " "; nazivIspitaDG = " " + ri.Naziv + " "; }
                }
                foreach (DataSet1.ProstorijaRow rp in dtProstorija.Rows)
                {
                    if (r.id_prostorije.Equals(rp.Naziv))
                        prostorijaDG += " " + rp.Naziv + " ";
                }

                foreach (DataSet1.ZakazaniRow rr in dtZ.Rows)
                {

                    if (j == 0) { j++; continue; }


                    if (r.id_prof.Equals(rr.id_prof) && r.id_ispita.Equals(rr.id_ispita) && !r.id_prostorije.Equals(rr.id_prostorije)
                    && r.Rok.Equals(rr.Rok) && r.DatumVreme.Equals(rr.DatumVreme) && !r.ID.Equals(rr.ID))
                        pom = true;
                    else
                        pom = false;

                    if (pom)
                    {
                        foreach (DataSet1.ProstorijaRow rp in dtProstorija.Rows)
                        {
                            if (rr.id_prostorije.Equals(rp.Naziv))
                                prostorijaDG += " , " + rp.Naziv;
                        }
                        niz[i++] = rr.ID;
                    }
                }
                dtZakazani.Rows.Add(r.ID, profDG, sifraIspitaDG, nazivIspitaDG, prostorijaDG, r.Rok, r.DatumVreme.Day + "." + r.DatumVreme.Month + "." + r.DatumVreme.Year + ".", r.DatumVreme.ToShortTimeString());
                profDG = ""; sifraIspitaDG = ""; nazivIspitaDG = ""; prostorijaDG = "";
            }

            dataGrid1.DataContext = dtZakazani;
            //*********************************************************************************>> sortiranje po ID
            ICollectionView view = CollectionViewSource.GetDefaultView(dataGrid1.Items);
            view.SortDescriptions.Clear();
            view.SortDescriptions.Add(new SortDescription("ID", ListSortDirection.Ascending));
            view.Refresh();

        }
        private void Load_comboBoxIspit()
        {
            string ime = ""; DataSet1.IspitiDataTable dtI = taI.GetData();
            DataTable dtPomIspit = new DataTable();
            dtPomIspit.Columns.Add("ID", typeof(int));
            dtPomIspit.Columns.Add("Ime", typeof(string));
            foreach (DataSet1.IspitiRow r in dtI.Rows)
            {
                if (comboBoxProfesor.SelectedValue.Equals(r.id_prof))
                {
                    ime += r.Sifra + " " + r.Naziv;
                    dtPomIspit.Rows.Add(r.Sifra, ime);
                    ime = "";
                }
            }
            Binding b = new Binding() { Source = dtPomIspit };
            this.comboBoxIspit.SetBinding(ComboBox.ItemsSourceProperty, b);
            this.comboBoxIspit.DisplayMemberPath = "Ime";
            this.comboBoxIspit.SelectedValuePath = "ID";
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //MessageBox.Show(tekst); 
            DataSet1.RokoviDataTable dtR = taR.GetData();
            DataSet1.ProfesoriDataTable dtP = taP.GetData();
            DataSet1.IspitiDataTable dtI = taI.GetData();
            DataSet1.ProstorijaDataTable dtProstorija = taProstorija.GetData();

            //***************************************************** Binding za comboBoxProfesor
            profesori.Add(new Profesor(0, "", "", "", "" ,"",""));

            foreach (DataSet1.ProfesoriRow r in dtP.Rows)
            {
                //string tekst = "";
                //fs = new FileStream(r.Ime + " " + r.Prezime + ".txt", FileMode.Open, FileAccess.Read);
                //sr = new StreamReader(fs);
                //while (!sr.EndOfStream)
                //    tekst = sr.ReadLine();
                //MessageBox.Show(tekst);
                profesori.Add(new Profesor(r.ID, r.Ime + " " + r.Prezime, r.Ime + " " + r.Prezime + ".jpg",r.Kabinet,r.Konsultacije,r.email,""));

            }
            this.GlavniStackPanel.DataContext = profesori;

            ucitaj_DataGrid();
            //********************************************************** Binding za comboBoxIspit
            string ime = "";
            DataTable dtPomIspit = new DataTable();
            dtPomIspit.Columns.Add("ID", typeof(int));
            dtPomIspit.Columns.Add("Ime", typeof(string));
            foreach (DataSet1.IspitiRow r in dtI.Rows)
            {
                ime += r.Sifra + " " + r.Naziv;
                dtPomIspit.Rows.Add(r.Sifra, ime);
                ime = "";
            }
            Binding b = new Binding() { Source = dtPomIspit };
            this.comboBoxIspit.SetBinding(ComboBox.ItemsSourceProperty, b);
            this.comboBoxIspit.DisplayMemberPath = "Ime";
            this.comboBoxIspit.SelectedValuePath = "ID";
            //****************************************************************** Binding za comboBoxProstorija
            //b = new Binding() { Source = dtProstorija };
            //this.comboBoxProstorija.SetBinding(ComboBox.ItemsSourceProperty, b);
            //this.comboBoxProstorija.DisplayMemberPath = "Naziv";
            //this.comboBoxProstorija.SelectedValuePath = "ID";
            foreach (DataSet1.ProstorijaRow r in dtProstorija.Rows)
            {
                prostorije.Add(new Prostorija(r.Kapacitet, false, r.Naziv));
            }
            this.comboBoxProstorija.DataContext = prostorije;
            //*********************************************************************************** puni comboBoxRok
            foreach (DataSet1.RokoviRow r in dtR.Rows)
            {
                comboBoxRok.Items.Add(r.ID);
            }

        }


        private void btnZakazi_Click(object sender, RoutedEventArgs e)
        {

            double sat = 0, min = 0;
            DateTime vreme = new DateTime();
            DateTime trajanje = new DateTime();
            sat = double.Parse(txtVremeSati.Text);
            min = double.Parse(txtVremeMin.Text);
            
            try { vreme = (DateTime)calendar.SelectedDate; }
            catch { vreme = calendar.DisplayDate; } 
            vreme = vreme.AddHours(sat);
            vreme = vreme.AddMinutes(min);

            sat = double.Parse(txtTrajanjeSati.Text);
            min = double.Parse(txtTrajanjeMin.Text);
            trajanje = trajanje.AddHours(sat);
            trajanje = trajanje.AddMinutes(min);
            try
            {
                bool prostorUnet = false;
                foreach (Prostorija p in prostorije)
                {
                    if (p.Check)
                    {
                        taZ.Insert(int.Parse(comboBoxProfesor.SelectedValue.ToString()),
                               int.Parse(comboBoxIspit.SelectedValue.ToString()),
                               p.Naziv,
                               comboBoxRok.SelectedItem.ToString(),
                               vreme,trajanje);
                        prostorUnet = true;
                    }

                }
                if (prostorUnet)
                    MessageBox.Show("Ispit zakazan !");
                else
                    MessageBox.Show("Niste izabrali sve podatke !");
            }
            catch
            {
                MessageBox.Show("Nije uspelo!");
            }
            ucitaj_DataGrid();
        }

        private void btnIzvezi_Click(object sender, RoutedEventArgs e)
        {
            dataGrid1.SelectionMode = DataGridSelectionMode.Extended;
            dataGrid1.SelectAllCells();
            dataGrid1.ClipboardCopyMode = DataGridClipboardCopyMode.IncludeHeader;
            ApplicationCommands.Copy.Execute(null, dataGrid1);
            string docPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "/Raspored_Ispita.csv";
            string dataExp = Clipboard.GetData(DataFormats.CommaSeparatedValue) as string;
            File.WriteAllText(docPath, dataExp);
            if (MessageBox.Show("Podaci sacuvani u Documents/Raspored_Ispita.csv . Da li zelite da otvorite taj fajl ?", "Podaci sacuvani u Excel dokumentu", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
            {
                Process.Start(docPath);

            }

            dataGrid1.UnselectAllCells();
        }


        private void btnBrisanje_Click(object sender, RoutedEventArgs e)
        {

            object selected = dataGrid1.SelectedItem;
            DataSet1.ZakazaniDataTable dtZ = taZ.GetData();
            try
            {
                DataRow row = ((DataRowView)selected).Row;
                int pomId = 0, pomId_prof = 0, pomId_ispit = 0;
                string pomRok = "", pomId_Prostor = ""; DateTime pomDatum = DateTime.Today, pomVreme = DateTime.Today;
                foreach (DataSet1.ZakazaniRow r in dtZ.Rows)
                {
                    if (!pomId.Equals(r.ID) && pomId_prof.Equals(r.id_prof) && pomId_ispit.Equals(r.id_ispita) &&
                        !pomId_Prostor.Equals(r.id_prostorije) && pomRok.Equals(r.Rok) && pomDatum.Equals(r.DatumVreme))
                    { taZ.Delete(r.ID, r.id_prof, r.id_ispita, r.id_prostorije, r.Rok, r.DatumVreme,r.Trajanje); }

                    pomId = r.ID; pomId_prof = r.id_prof; pomId_ispit = r.id_ispita; pomId_Prostor = r.id_prostorije;
                    pomRok = r.Rok; pomDatum = r.DatumVreme; 

                    if (r.ID.Equals(row[0]))
                        if (MessageBox.Show("Da li ste sigurni da zelite da obrisete izabrani ispit ?", " ", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                        { taZ.Delete(r.ID, r.id_prof, r.id_ispita, r.id_prostorije, r.Rok, r.DatumVreme,r.Trajanje); }
                }
            }
            catch
            {
                MessageBox.Show("Morate prvo izabrati jedan ispit (red u tabeli) !");
            }
            ucitaj_DataGrid(); // nejasno zasto taZ.Delete(... trazi ovoliko argumenata a ne samo ID
        }

        private void comboBoxProfesor_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Load_comboBoxIspit();
            //lblProfKabinet.Visibility = Visibility.Visible;
            //lblProfKonsult.Visibility = Visibility.Visible;
            //lblProfEmail.Visibility = Visibility.Visible;
        }
        private void DrawRectangle()
        {
            Rectangle kv = new Rectangle();
            SolidColorBrush red = new SolidColorBrush(Colors.Red);
            kv.Fill = red;
            kv.Height = 150; kv.Height = 150;
            canvas.Children.Insert(0, kv);
        }
        private void calendar_SelectedDatesChanged(object sender, SelectionChangedEventArgs e)
        {
            DrawRectangle(); 
        }


    }
}
